/***************************************************************************
                          sdl_freetype.h  -  description
                             -------------------
    begin                : Thu Aug 30 2001
    copyright            : (C) 2001 by Ales Teska
    email                : teska@dbsystem.cz
 ***************************************************************************/

import SDL;

extern (C):

SDL_version *FreeType_Linked_Version();

//Format character definitions
//Format character definitions
const int SDL_FTFORMAT_STYLESET = 0x01;
const int SDL_FTFORMAT_SIZESET = 0x02;
const int SDL_FTFORMAT_ALPHASET = 0x04;
const int SDL_FTFORMAT_COLORSET = 0x08;
const int SDL_FTFORMAT_INDEXSET = 0x10;
const int SDL_FTFORMAT_NAMESET = 0x20;
const int SDL_FTFORMAT_EMPTY = 	0x40;
const int SDL_FTFORMAT_END = 	0x80;

const int SDL_FTFORMAT_STYLE_OR = 0x02;
const int SDL_FTFORMAT_STYLE_NAND = 0x03;
const int SDL_FTFORMAT_SIZESET_OFF = 0x01;

const char SDL_FTFORMAT_TAG = '\010';
const char* SDL_FTFT_END_TAG = "\010\200";

//Font style definiton
const int SDL_FTSTYLE_NORMAL = 0x00;
const int SDL_FTSTYLE_BOLD = 0x01;
const int SDL_FTSTYLE_ITALIC = 0x02;
const int SDL_FTSTYLE_UNDERLINE = 0x04;

//Structures
struct SDL_FontFaceDescription {
	int		Size;
	int		Index;
	char		Name[8192];
}

alias void SDL_FontFaceCacheItem;
alias void SDL_FontChangeHist;

struct SDL_FontParam {
	SDL_Color			Color;
	int				Alpha;
	int				Style;

	SDL_FontFaceDescription		FaceDescr;
    /* private use */
	SDL_FontFaceCacheItem		*FaceCache;
	SDL_FontChangeHist		*FontChangeHistory;
}

//Public funtions

int SDL_InitFreeType();
int SDL_DoneFreeType();

char *SDL_FreeTypeGetVersion();

int SDL_FormatTagProc(char *c, SDL_FontParam *Param, int Evidence);

int SDL_RenderTextUNICODE(SDL_Surface *Surface, int BaseLineX, int BaseLineY, Uint16 *Text, SDL_FontParam *ParamIn, SDL_FontParam *ParamOut);
int SDL_RenderTextASCII(SDL_Surface *Surface, int BaseLineX, int BaseLineY, char *Text, SDL_FontParam *ParamIn, SDL_FontParam *ParamOut);
int SDL_RenderTextWIDE(SDL_Surface *Surface, int BaseLineX, int BaseLineY, wchar *Text, SDL_FontParam *ParamIn, SDL_FontParam *ParamOut);

int SDL_GetTextSizeUNICODE(Uint16 *Text, SDL_FontParam *ParamIn, SDL_FontParam *ParamOut, int *Width, int *Height, int *BaselineY, int *FontLineSkip, int *FontHeight, int *Ascent, int *Descent);
int SDL_GetTextSizeASCII(char *Text, SDL_FontParam *ParamIn, SDL_FontParam *ParamOut, int *Width, int *Height, int *BaselineY, int *FontLineSkip, int *FontHeight, int *Ascent, int *Descent);
int SDL_GetTextSizeWIDE(wchar *Text, SDL_FontParam *ParamIn, SDL_FontParam *ParamOut, int *Width, int *Height, int *BaselineY, int *FontLineSkip, int *FontHeight, int *Ascent, int *Descent);

//Global variables
extern SDL_FontParam		SDL_DefaultFont;

